# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetWildfireAntiVirusProfileResult',
    'AwaitableGetWildfireAntiVirusProfileResult',
    'get_wildfire_anti_virus_profile',
    'get_wildfire_anti_virus_profile_output',
]

@pulumi.output_type
class GetWildfireAntiVirusProfileResult:
    """
    A collection of values returned by getWildfireAntiVirusProfile.
    """
    def __init__(__self__, description=None, id=None, mlav_exceptions=None, name=None, packet_capture=None, rules=None, tfid=None, threat_exceptions=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if mlav_exceptions and not isinstance(mlav_exceptions, list):
            raise TypeError("Expected argument 'mlav_exceptions' to be a list")
        pulumi.set(__self__, "mlav_exceptions", mlav_exceptions)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if packet_capture and not isinstance(packet_capture, bool):
            raise TypeError("Expected argument 'packet_capture' to be a bool")
        pulumi.set(__self__, "packet_capture", packet_capture)
        if rules and not isinstance(rules, list):
            raise TypeError("Expected argument 'rules' to be a list")
        pulumi.set(__self__, "rules", rules)
        if tfid and not isinstance(tfid, str):
            raise TypeError("Expected argument 'tfid' to be a str")
        pulumi.set(__self__, "tfid", tfid)
        if threat_exceptions and not isinstance(threat_exceptions, list):
            raise TypeError("Expected argument 'threat_exceptions' to be a list")
        pulumi.set(__self__, "threat_exceptions", threat_exceptions)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The Description param.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The Id param.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="mlavExceptions")
    def mlav_exceptions(self) -> Sequence['outputs.GetWildfireAntiVirusProfileMlavExceptionResult']:
        """
        The MlavExceptions param.
        """
        return pulumi.get(self, "mlav_exceptions")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The Name param. String validation regex: `^[a-zA-Z0-9._-]+$`.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="packetCapture")
    def packet_capture(self) -> bool:
        """
        The PacketCapture param.
        """
        return pulumi.get(self, "packet_capture")

    @property
    @pulumi.getter
    def rules(self) -> Sequence['outputs.GetWildfireAntiVirusProfileRuleResult']:
        """
        The Rules param.
        """
        return pulumi.get(self, "rules")

    @property
    @pulumi.getter
    def tfid(self) -> str:
        return pulumi.get(self, "tfid")

    @property
    @pulumi.getter(name="threatExceptions")
    def threat_exceptions(self) -> Sequence['outputs.GetWildfireAntiVirusProfileThreatExceptionResult']:
        """
        The ThreatExceptions param.
        """
        return pulumi.get(self, "threat_exceptions")


class AwaitableGetWildfireAntiVirusProfileResult(GetWildfireAntiVirusProfileResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetWildfireAntiVirusProfileResult(
            description=self.description,
            id=self.id,
            mlav_exceptions=self.mlav_exceptions,
            name=self.name,
            packet_capture=self.packet_capture,
            rules=self.rules,
            tfid=self.tfid,
            threat_exceptions=self.threat_exceptions)


def get_wildfire_anti_virus_profile(id: Optional[str] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetWildfireAntiVirusProfileResult:
    """
    Retrieves a config item.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_scm as scm

    example = scm.get_wildfire_anti_virus_profile(id="1234-56-789")
    ```


    :param str id: The Id param.
    """
    __args__ = dict()
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('scm:index/getWildfireAntiVirusProfile:getWildfireAntiVirusProfile', __args__, opts=opts, typ=GetWildfireAntiVirusProfileResult).value

    return AwaitableGetWildfireAntiVirusProfileResult(
        description=pulumi.get(__ret__, 'description'),
        id=pulumi.get(__ret__, 'id'),
        mlav_exceptions=pulumi.get(__ret__, 'mlav_exceptions'),
        name=pulumi.get(__ret__, 'name'),
        packet_capture=pulumi.get(__ret__, 'packet_capture'),
        rules=pulumi.get(__ret__, 'rules'),
        tfid=pulumi.get(__ret__, 'tfid'),
        threat_exceptions=pulumi.get(__ret__, 'threat_exceptions'))
def get_wildfire_anti_virus_profile_output(id: Optional[pulumi.Input[str]] = None,
                                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetWildfireAntiVirusProfileResult]:
    """
    Retrieves a config item.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_scm as scm

    example = scm.get_wildfire_anti_virus_profile(id="1234-56-789")
    ```


    :param str id: The Id param.
    """
    __args__ = dict()
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('scm:index/getWildfireAntiVirusProfile:getWildfireAntiVirusProfile', __args__, opts=opts, typ=GetWildfireAntiVirusProfileResult)
    return __ret__.apply(lambda __response__: GetWildfireAntiVirusProfileResult(
        description=pulumi.get(__response__, 'description'),
        id=pulumi.get(__response__, 'id'),
        mlav_exceptions=pulumi.get(__response__, 'mlav_exceptions'),
        name=pulumi.get(__response__, 'name'),
        packet_capture=pulumi.get(__response__, 'packet_capture'),
        rules=pulumi.get(__response__, 'rules'),
        tfid=pulumi.get(__response__, 'tfid'),
        threat_exceptions=pulumi.get(__response__, 'threat_exceptions')))
